# Copyright (c) 2000-2011, JPackage Project
# All rights reserved.
#
# Redistribution and use in source and binary forms, with or without
# modification, are permitted provided that the following conditions
# are met:
#
# 1. Redistributions of source code must retain the above copyright
#    notice, this list of conditions and the following disclaimer.
# 2. Redistributions in binary form must reproduce the above copyright
#    notice, this list of conditions and the following disclaimer in the
#    documentation and/or other materials provided with the
#    distribution.
# 3. Neither the name of the JPackage Project nor the names of its
#    contributors may be used to endorse or promote products derived
#    from this software without specific prior written permission.
#
# THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS
# "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT
# LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR
# A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT
# OWNER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL,
# SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT
# LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
# DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
# THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
# (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE
# OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
#

%define section         free

Name:           ops4j-pax-logging
Summary:        Pax bundle scanner
Url:            http://www.ops4j.org/
Version:        1.6.1
Release:        2%{?dist}
Epoch:          0
License:        Apache 2.0 License
Group:          Development/Libraries
Source0:        ops4j-pax-logging-1.6.1.tgz
# git clone http://github.com/ops4j/org.ops4j.pax.logging.git
# cd org.ops4j.pax.logging/
# git-tag -l
# mkdir ../ops4j-pax-logging-1.6.1
# git archive logging-1.6.1 | tar -x -C ../ops4j-pax-logging-1.6.1
# cd ..
# tar czf ops4j-pax-logging-1.6.1.tgz ops4j-pax-logging-1.6.1/

Source1:        %{name}-settings.xml
Source2:        %{name}-jpp-depmap.xml

Patch1:         ops4j-pax-logging-service-pom.patch

Patch99:        ops4j-pax-logging-bootstrap-pom.patch

BuildRequires:  jpackage-utils >= 0:1.7.5
BuildRequires:  java-devel >= 0:1.6.0
BuildRequires:  ant >= 0:1.7.1
BuildRequires:  maven2 >= 0:2.0.8
BuildRequires:  maven2-plugin-compiler
BuildRequires:  maven2-plugin-dependency
BuildRequires:  maven2-plugin-idea
BuildRequires:  maven2-plugin-install
BuildRequires:  maven2-plugin-jar
BuildRequires:  maven2-plugin-javadoc
BuildRequires:  maven2-plugin-plugin
BuildRequires:  maven2-plugin-release
BuildRequires:  maven2-plugin-remote-resources
BuildRequires:  maven2-plugin-resources
BuildRequires:  maven-surefire-maven-plugin
BuildRequires:  maven-surefire-provider-junit4
BuildRequires:  apache-commons-parent
BuildRequires:  apache-felix-maven-bundle-plugin

BuildRequires:  ops4j-pax-master
BuildRequires:  ops4j-pax-construct
BuildRequires:  jetty5

BuildRequires:  excalibur-avalon-framework-api
BuildRequires:  org.osgi.core
BuildRequires:  org.osgi.compendium

Requires(post):    jpackage-utils >= 0:1.7.5
Requires(postun):  jpackage-utils >= 0:1.7.5
Requires:  java >= 0:1.6.0
Requires:  excalibur-avalon-framework-api
Requires:  org.osgi.core
Requires:  org.osgi.compendium

BuildArch:      noarch
BuildRoot:      %{_tmppath}/%{name}-%{version}-buildroot

%description
The bundle scanner installs bundles specified by bundles url.

%package javadoc
Summary:        Javadoc for %{name}
Group:          Development/Documentation

%description javadoc
%{summary}.

%prep
%setup -q 
chmod -R go=u-w *
cp %{SOURCE1} settings.xml
%patch1 -b .sav1

# omit integration tests while no pax-exam available
%patch99 -b .sav99

%build
sed -i -e "s|<url>__JPP_URL_PLACEHOLDER__</url>|<url>file://`pwd`/.m2/repository</url>|g" settings.xml
sed -i -e "s|<url>__JAVADIR_PLACEHOLDER__</url>|<url>file://`pwd`/external_repo</url>|g" settings.xml
sed -i -e "s|<url>__MAVENREPO_DIR_PLACEHOLDER__</url>|<url>file://`pwd`/.m2/repository</url>|g" settings.xml

export MAVEN_REPO_LOCAL=$(pwd)/.m2/repository

mkdir external_repo
ln -s %{_javadir} external_repo/JPP

export SETTINGS=$(pwd)/settings.xml

mvn-jpp \
        -e \
        -s $SETTINGS \
        -Dmaven2.jpp.depmap.file=%{SOURCE2} \
        -Dmaven.repo.local=$MAVEN_REPO_LOCAL \
        -Dmaven.test.failure.ignore=true \
        install 
mvn-jpp \
        -e \
        -s $SETTINGS \
        -Dmaven2.jpp.depmap.file=%{SOURCE2} \
        -Dmaven.repo.local=$MAVEN_REPO_LOCAL \
        -Daggregate=true \
        javadoc:javadoc

%install
rm -rf $RPM_BUILD_ROOT

# jars
install -d -m 755 $RPM_BUILD_ROOT%{_javadir}/%{name}
install -d -m 755 $RPM_BUILD_ROOT%{_datadir}/maven2/poms

%add_to_maven_depmap org.ops4j.pax logging %{version} JPP/%{name} logging
install -m 644 pom.xml $RPM_BUILD_ROOT%{_datadir}/maven2/poms/JPP.%{name}-logging.pom

%add_to_maven_depmap org.ops4j.pax.logging pax-logging-api %{version} JPP/%{name} api
install -m 644 pax-logging-api/pom.xml $RPM_BUILD_ROOT%{_datadir}/maven2/poms/JPP.%{name}-api.pom
install -m 644 pax-logging-api/target/pax-logging-api-%{version}.jar $RPM_BUILD_ROOT%{_javadir}/%{name}/api-%{version}.jar

%add_to_maven_depmap org.ops4j.pax.logging pax-logging-service %{version} JPP/%{name} service
install -m 644 pax-logging-service/pom.xml $RPM_BUILD_ROOT%{_datadir}/maven2/poms/JPP.%{name}-service.pom
install -m 644 pax-logging-service/target/pax-logging-service-%{version}.jar $RPM_BUILD_ROOT%{_javadir}/%{name}/service-%{version}.jar

%add_to_maven_depmap org.ops4j.pax.logging pax-logging-samples %{version} JPP/%{name} samples
install -m 644 pax-logging-samples/pom.xml $RPM_BUILD_ROOT%{_datadir}/maven2/poms/JPP.%{name}-samples.pom

%add_to_maven_depmap org.ops4j.pax.logging pax-logging-sample-config %{version} JPP/%{name} sample-config
install -m 644 pax-logging-samples/config/pom.xml $RPM_BUILD_ROOT%{_datadir}/maven2/poms/JPP.%{name}-sample-config.pom
install -m 644 pax-logging-samples/config/target/pax-logging-sample-config-%{version}.jar $RPM_BUILD_ROOT%{_javadir}/%{name}/sample-config-%{version}.jar

%add_to_maven_depmap org.ops4j.pax.logging pax-logging-sample-logger %{version} JPP/%{name} sample-logger
install -m 644 pax-logging-samples/logger/pom.xml $RPM_BUILD_ROOT%{_datadir}/maven2/poms/JPP.%{name}-sample-logger.pom
install -m 644 pax-logging-samples/logger/target/pax-logging-sample-logger-%{version}.jar $RPM_BUILD_ROOT%{_javadir}/%{name}/sample-logger-%{version}.jar

(cd $RPM_BUILD_ROOT%{_javadir}/%{name} && for jar in *-%{version}.jar; do ln -sf ${jar} `echo $jar| sed  "s|-%{version}||g"`; done)

# javadoc
install -d -m 755 $RPM_BUILD_ROOT%{_javadocdir}/%{name}-%{version}
cp -pr target/site/apidocs/* $RPM_BUILD_ROOT%{_javadocdir}/%{name}-%{version}
ln -s %{name}-%{version} $RPM_BUILD_ROOT%{_javadocdir}/%{name} # ghost symlink

%clean
rm -rf $RPM_BUILD_ROOT

%post
%update_maven_depmap

%postun
%update_maven_depmap

%files
%defattr(-,root,root)
%dir %{_javadir}/%{name}
%{_javadir}/%{name}/*.jar
%{_datadir}/maven2/poms/*
%{_mavendepmapfragdir}/*

%files javadoc
%defattr(-,root,root,-)
%doc %{_javadocdir}/*

%changelog
* Sun Dec 04 2011 Ralph Apel <r.apel at r-apel.de> 0:1.6.1-2
- Promote to free

* Tue Jun 21 2011 Ralph Apel <r.apel at r-apel.de> 0:1.6.1-1
- First standalone release
